Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionsPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionsPool.cpp	(revision 29697)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionsPool.cpp	(revision 29700)
@@ -161,6 +161,14 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Fullscreen Mode"), "F"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to fullscreen mode"));
+        if (!isChecked())
+        {
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Enter &Fullscreen Mode"), "F"));
+            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to fullscreen mode"));
+        }
+        else
+        {
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Exit &Fullscreen Mode"), "F"));
+            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to normal mode"));
+        }
     }
 };
@@ -184,6 +192,14 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Seam&less Mode"), "L"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to seamless desktop integration mode"));
+        if (!isChecked())
+        {
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Enter Seam&less Mode"), "L"));
+            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to seamless desktop integration mode"));
+        }
+        else
+        {
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Exit Seam&less Mode"), "L"));
+            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to normal mode"));
+        }
     }
 };
@@ -207,6 +223,14 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Auto-resize &Guest Display"), "G"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Automatically resize the guest display when the window is resized (requires Guest Additions)"));
+        if (!isChecked())
+        {
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Enable &Guest Display Auto-resize"), "G"));
+            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Automatically resize the guest display when the window is resized (requires Guest Additions)"));
+        }
+        else
+        {
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Disable &Guest Display Auto-resize"), "G"));
+            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Disable automatic resize of the guest display when the window is resized"));
+        }
     }
 };
@@ -791,5 +815,12 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "&Logging...", "debug action"));
+        if (!isChecked())
+        {
+            setText(QApplication::translate("VBoxConsoleWnd", "Enable &Logging...", "debug action"));
+        }
+        else
+        {
+            setText(QApplication::translate("VBoxConsoleWnd", "Disable &Logging...", "debug action"));
+        }
     }
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 29697)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 29700)
@@ -18,4 +18,7 @@
  */
 
+/* Global includes */
+#include <QTimer>
+
 /* Local includes */
 #include "VBoxGlobal.h"
@@ -165,4 +168,5 @@
             pActionFullscreen->blockSignals(true);
             pActionFullscreen->setChecked(true);
+            QTimer::singleShot(0, pActionFullscreen, SLOT(sltUpdateAppearance()));
             pActionFullscreen->blockSignals(false);
         }
@@ -178,4 +182,5 @@
             pActionFullscreen->blockSignals(true);
             pActionFullscreen->setChecked(false);
+            QTimer::singleShot(0, pActionFullscreen, SLOT(sltUpdateAppearance()));
             pActionFullscreen->blockSignals(false);
         }
@@ -227,4 +232,5 @@
             pActionSeamless->blockSignals(true);
             pActionSeamless->setChecked(true);
+            QTimer::singleShot(0, pActionSeamless, SLOT(sltUpdateAppearance()));
             pActionSeamless->blockSignals(false);
         }
@@ -240,4 +246,5 @@
             pActionSeamless->blockSignals(true);
             pActionSeamless->setChecked(false);
+            QTimer::singleShot(0, pActionSeamless, SLOT(sltUpdateAppearance()));
             pActionSeamless->blockSignals(false);
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 29697)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 29700)
@@ -1200,7 +1200,5 @@
         strSettings = machine.GetExtraData(VBoxDefs::GUI_AutoresizeGuest);
         QAction *pGuestAutoresizeSwitch = uimachine()->actionsPool()->action(UIActionIndex_Toggle_GuestAutoresize);
-        pGuestAutoresizeSwitch->blockSignals(true);
         pGuestAutoresizeSwitch->setChecked(strSettings != "off");
-        pGuestAutoresizeSwitch->blockSignals(false);
     }
 }