Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionsPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionsPool.cpp	(revision 29733)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionsPool.cpp	(revision 29734)
@@ -139,5 +139,5 @@
     void retranslateUi()
     {
-        menu()->setTitle(QApplication::translate("VBoxConsoleWnd", "&Machine"));
+        menu()->setTitle(QApplication::translate("UIActionsPool", "&Machine"));
     }
 };
@@ -163,11 +163,11 @@
         if (!isChecked())
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Enter &Fullscreen Mode"), "F"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to fullscreen mode"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Enter &Fullscreen Mode"), "F"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Switch to fullscreen mode"));
         }
         else
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Exit &Fullscreen Mode"), "F"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to normal mode"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Exit &Fullscreen Mode"), "F"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Switch to normal mode"));
         }
     }
@@ -194,11 +194,11 @@
         if (!isChecked())
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Enter Seam&less Mode"), "L"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to seamless desktop integration mode"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Enter Seam&less Mode"), "L"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Switch to seamless desktop integration mode"));
         }
         else
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Exit Seam&less Mode"), "L"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Switch to normal mode"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Exit Seam&less Mode"), "L"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Switch to normal mode"));
         }
     }
@@ -225,11 +225,11 @@
         if (!isChecked())
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Enable &Guest Display Auto-resize"), "G"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Automatically resize the guest display when the window is resized (requires Guest Additions)"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Enable &Guest Display Auto-resize"), "G"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Automatically resize the guest display when the window is resized (requires Guest Additions)"));
         }
         else
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Disable &Guest Display Auto-resize"), "G"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Disable automatic resize of the guest display when the window is resized"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Disable &Guest Display Auto-resize"), "G"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Disable automatic resize of the guest display when the window is resized"));
         }
     }
@@ -253,6 +253,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Adjust Window Size"), "A"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Adjust window size and position to best fit the guest display"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "&Adjust Window Size"), "A"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Adjust window size and position to best fit the guest display"));
     }
 };
@@ -297,11 +297,11 @@
         if (!isChecked())
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Disable &Mouse Integration"), "I"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Temporarily disable host mouse pointer integration"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Disable &Mouse Integration"), "I"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Temporarily disable host mouse pointer integration"));
         }
         else
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Enable &Mouse Integration"), "I"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Enable temporarily disabled host mouse pointer integration"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Enable &Mouse Integration"), "I"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Enable temporarily disabled host mouse pointer integration"));
         }
     }
@@ -325,6 +325,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Insert Ctrl-Alt-Del"), "Del"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Send the Ctrl-Alt-Del sequence to the virtual machine"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "&Insert Ctrl-Alt-Del"), "Del"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Send the Ctrl-Alt-Del sequence to the virtual machine"));
     }
 };
@@ -348,6 +348,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Insert Ctrl-Alt-Backspace"), "Backspace"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Send the Ctrl-Alt-Backspace sequence to the virtual machine"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "&Insert Ctrl-Alt-Backspace"), "Backspace"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Send the Ctrl-Alt-Backspace sequence to the virtual machine"));
     }
 };
@@ -371,6 +371,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Take &Snapshot..."), "S"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Take a snapshot of the virtual machine"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Take &Snapshot..."), "S"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Take a snapshot of the virtual machine"));
     }
 };
@@ -393,6 +393,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "Session I&nformation Dialog"), "N"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Show Session Information Dialog"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "Session I&nformation Dialog"), "N"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Show Session Information Dialog"));
     }
 };
@@ -417,11 +417,11 @@
         if (!isChecked())
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Pause"), "P"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Suspend the execution of the virtual machine"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "&Pause"), "P"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Suspend the execution of the virtual machine"));
         }
         else
         {
-            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "R&esume"), "P"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Resume the execution of the virtual machine"));
+            setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "R&esume"), "P"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Resume the execution of the virtual machine"));
         }
     }
@@ -445,6 +445,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Reset"), "R"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Reset the virtual machine"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "&Reset"), "R"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Reset the virtual machine"));
     }
 };
@@ -469,9 +469,9 @@
 #ifdef Q_WS_MAC
         /* Host+H is Hide on the mac */
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "ACPI Sh&utdown"), "U"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "ACPI Sh&utdown"), "U"));
 #else /* Q_WS_MAC */
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "ACPI S&hutdown"), "H"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "ACPI S&hutdown"), "H"));
 #endif /* !Q_WS_MAC */
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Send the ACPI Power Button press event to the virtual machine"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Send the ACPI Power Button press event to the virtual machine"));
     }
 };
@@ -495,6 +495,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Close..." ), "Q"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Close the virtual machine"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "&Close..." ), "Q"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Close the virtual machine"));
     }
 };
@@ -516,5 +516,5 @@
     void retranslateUi()
     {
-        menu()->setTitle(QApplication::translate("VBoxConsoleWnd", "&View"));
+        menu()->setTitle(QApplication::translate("UIActionsPool", "&View"));
     }
 };
@@ -536,5 +536,5 @@
     void retranslateUi()
     {
-        menu()->setTitle(QApplication::translate("VBoxConsoleWnd", "&Devices"));
+        menu()->setTitle(QApplication::translate("UIActionsPool", "&Devices"));
     }
 };
@@ -557,5 +557,5 @@
     void retranslateUi()
     {
-        menu()->setTitle(QApplication::translate("VBoxConsoleWnd", "&CD/DVD Devices"));
+        menu()->setTitle(QApplication::translate("UIActionsPool", "&CD/DVD Devices"));
     }
 };
@@ -578,5 +578,5 @@
     void retranslateUi()
     {
-        menu()->setTitle(QApplication::translate("VBoxConsoleWnd", "&Floppy Devices"));
+        menu()->setTitle(QApplication::translate("UIActionsPool", "&Floppy Devices"));
     }
 };
@@ -599,5 +599,5 @@
     void retranslateUi()
     {
-        menu()->setTitle(QApplication::translate("VBoxConsoleWnd", "&USB Devices"));
+        menu()->setTitle(QApplication::translate("UIActionsPool", "&USB Devices"));
     }
 };
@@ -639,6 +639,6 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "&Network Adapters..."));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Change the settings of network adapters"));
+        setText(QApplication::translate("UIActionsPool", "&Network Adapters..."));
+        setStatusTip(QApplication::translate("UIActionsPool", "Change the settings of network adapters"));
     }
 };
@@ -680,6 +680,6 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "&Shared Folders..."));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Create or modify shared folders"));
+        setText(QApplication::translate("UIActionsPool", "&Shared Folders..."));
+        setStatusTip(QApplication::translate("UIActionsPool", "Create or modify shared folders"));
     }
 };
@@ -705,11 +705,11 @@
         if (!isChecked())
         {
-            setText(QApplication::translate("VBoxConsoleWnd", "&Enable Remote Display"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Enable remote desktop (RDP) connections to this machine"));
+            setText(QApplication::translate("UIActionsPool", "&Enable Remote Display"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Enable remote desktop (RDP) connections to this machine"));
         }
         else
         {
-            setText(QApplication::translate("VBoxConsoleWnd", "&Disable Remote Display"));
-            setStatusTip(QApplication::translate("VBoxConsoleWnd", "Disable remote desktop (RDP) connections to this machine"));
+            setText(QApplication::translate("UIActionsPool", "&Disable Remote Display"));
+            setStatusTip(QApplication::translate("UIActionsPool", "Disable remote desktop (RDP) connections to this machine"));
         }
     }
@@ -733,6 +733,6 @@
     void retranslateUi()
     {
-        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("VBoxConsoleWnd", "&Install Guest Additions..."), "D"));
-        setStatusTip(QApplication::translate("VBoxConsoleWnd", "Mount the Guest Additions installation image"));
+        setText(VBoxGlobal::insertKeyToActionText(QApplication::translate("UIActionsPool", "&Install Guest Additions..."), "D"));
+        setStatusTip(QApplication::translate("UIActionsPool", "Mount the Guest Additions installation image"));
     }
 };
@@ -755,5 +755,5 @@
     void retranslateUi()
     {
-        menu()->setTitle(QApplication::translate("VBoxConsoleWnd", "De&bug"));
+        menu()->setTitle(QApplication::translate("UIActionsPool", "De&bug"));
     }
 };
@@ -775,5 +775,5 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "&Statistics...", "debug action"));
+        setText(QApplication::translate("UIActionsPool", "&Statistics...", "debug action"));
     }
 };
@@ -795,5 +795,5 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "&Command Line...", "debug action"));
+        setText(QApplication::translate("UIActionsPool", "&Command Line...", "debug action"));
     }
 };
@@ -816,11 +816,7 @@
     {
         if (!isChecked())
-        {
-            setText(QApplication::translate("VBoxConsoleWnd", "Enable &Logging...", "debug action"));
-        }
+            setText(QApplication::translate("UIActionsPool", "Enable &Logging...", "debug action"));
         else
-        {
-            setText(QApplication::translate("VBoxConsoleWnd", "Disable &Logging...", "debug action"));
-        }
+            setText(QApplication::translate("UIActionsPool", "Disable &Logging...", "debug action"));
     }
 };
@@ -843,5 +839,5 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "&Help"));
+        setText(QApplication::translate("UIActionsPool", "&Help"));
     }
 };
@@ -1020,5 +1016,5 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "Dock Icon"));
+        setText(QApplication::translate("UIActionsPool", "Dock Icon"));
     }
 };
@@ -1040,5 +1036,5 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "Show Monitor Preview"));
+        setText(QApplication::translate("UIActionsPool", "Show Monitor Preview"));
     }
 };
@@ -1060,5 +1056,5 @@
     void retranslateUi()
     {
-        setText(QApplication::translate("VBoxConsoleWnd", "Show Application Icon"));
+        setText(QApplication::translate("UIActionsPool", "Show Application Icon"));
     }
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 29733)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 29734)
@@ -56,5 +56,5 @@
         const CMachine &machine = m_session.GetMachine();
 
-        QString strToolTip = QApplication::translate("VBoxConsoleWnd", "<p style='white-space:pre'><nobr>Indicates the activity "
+        QString strToolTip = QApplication::translate("UIIndicatorsPool", "<p style='white-space:pre'><nobr>Indicates the activity "
                                                      "of the virtual hard disks:</nobr>%1</p>", "HDD tooltip");
 
@@ -84,5 +84,5 @@
             setHidden(true);
         //if (!fAttachmentsPresent)
-        //    strFullData += QApplication::translate("VBoxConsoleWnd", "<br><nobr><b>No hard disks attached</b></nobr>", "HDD tooltip");
+        //    strFullData += QApplication::translate("UIIndicatorsPool", "<br><nobr><b>No hard disks attached</b></nobr>", "HDD tooltip");
 
         setToolTip(strToolTip.arg(strFullData));
@@ -123,5 +123,5 @@
         const CMachine &machine = m_session.GetMachine();
 
-        QString strToolTip = QApplication::translate("VBoxConsoleWnd", "<p style='white-space:pre'><nobr>Indicates the activity "
+        QString strToolTip = QApplication::translate("UIIndicatorsPool", "<p style='white-space:pre'><nobr>Indicates the activity "
                                                      "of the CD/DVD devices:</nobr>%1</p>", "CD/DVD tooltip");
 
@@ -155,5 +155,5 @@
             setHidden(true);
         //if (!fAttachmentsPresent)
-        //    strFullData = QApplication::translate("VBoxConsoleWnd", "<br><nobr><b>No CD/DVD devices attached</b></nobr>", "CD/DVD tooltip");
+        //    strFullData = QApplication::translate("UIIndicatorsPool", "<br><nobr><b>No CD/DVD devices attached</b></nobr>", "CD/DVD tooltip");
 
         setToolTip(strToolTip.arg(strFullData));
@@ -194,5 +194,5 @@
         const CMachine &machine = m_session.GetMachine();
 
-        QString strToolTip = QApplication::translate("VBoxConsoleWnd", "<p style='white-space:pre'><nobr>Indicates the activity "
+        QString strToolTip = QApplication::translate("UIIndicatorsPool", "<p style='white-space:pre'><nobr>Indicates the activity "
                                                      "of the floppy devices:</nobr>%1</p>", "FD tooltip");
 
@@ -226,5 +226,5 @@
             setHidden(true);
         //if (!fAttachmentsPresent)
-        //    strFullData = QApplication::translate("VBoxConsoleWnd", "<br><nobr><b>No floppy devices attached</b></nobr>", "FD tooltip");
+        //    strFullData = QApplication::translate("UIIndicatorsPool", "<br><nobr><b>No floppy devices attached</b></nobr>", "FD tooltip");
 
         setToolTip(strToolTip.arg(strFullData));
@@ -272,5 +272,5 @@
         ulong uMaxCount = vboxGlobal().virtualBox().GetSystemProperties().GetNetworkAdapterCount();
 
-        QString strToolTip = QApplication::translate("VBoxConsoleWnd",
+        QString strToolTip = QApplication::translate("UIIndicatorsPool",
                                  "<p style='white-space:pre'><nobr>Indicates the activity of the "
                                  "network interfaces:</nobr>%1</p>", "Network adapters tooltip");
@@ -309,5 +309,5 @@
                         strGuestIp = ipList[iIp];
                 }
-                strFullData += QApplication::translate("VBoxConsoleWnd",
+                strFullData += QApplication::translate("UIIndicatorsPool",
                                "<br><nobr><b>Adapter %1 (%2)</b>: %3 cable %4</nobr>", "Network adapters tooltip")
                     .arg(uSlot + 1)
@@ -315,6 +315,6 @@
                     .arg(strGuestIp.isEmpty() ? "" : "IP " + strGuestIp + ", ")
                     .arg(adapter.GetCableConnected() ?
-                         QApplication::translate("VBoxConsoleWnd", "connected", "Network adapters tooltip") :
-                         QApplication::translate("VBoxConsoleWnd", "disconnected", "Network adapters tooltip"));
+                         QApplication::translate("UIIndicatorsPool", "connected", "Network adapters tooltip") :
+                         QApplication::translate("UIIndicatorsPool", "disconnected", "Network adapters tooltip"));
                 ++uEnabled;
             }
@@ -326,5 +326,5 @@
 
         if (strFullData.isNull())
-            strFullData = QApplication::translate("VBoxConsoleWnd",
+            strFullData = QApplication::translate("UIIndicatorsPool",
                               "<br><nobr><b>All network adapters are disabled</b></nobr>", "Network adapters tooltip");
 
@@ -372,5 +372,5 @@
         const CMachine &machine = m_session.GetMachine();
 
-        QString strToolTip = QApplication::translate("VBoxConsoleWnd", "<p style='white-space:pre'><nobr>Indicates the activity of "
+        QString strToolTip = QApplication::translate("UIIndicatorsPool", "<p style='white-space:pre'><nobr>Indicates the activity of "
                                 "the attached USB devices:</nobr>%1</p>", "USB device tooltip");
         QString strFullData;
@@ -389,8 +389,8 @@
             }
             if (strFullData.isNull())
-                strFullData = QApplication::translate("VBoxConsoleWnd", "<br><nobr><b>No USB devices attached</b></nobr>", "USB device tooltip");
+                strFullData = QApplication::translate("UIIndicatorsPool", "<br><nobr><b>No USB devices attached</b></nobr>", "USB device tooltip");
         }
         else
-            strFullData = QApplication::translate("VBoxConsoleWnd", "<br><nobr><b>USB Controller is disabled</b></nobr>", "USB device tooltip");
+            strFullData = QApplication::translate("UIIndicatorsPool", "<br><nobr><b>USB Controller is disabled</b></nobr>", "USB device tooltip");
 
         setToolTip(strToolTip.arg(strFullData));
@@ -431,5 +431,5 @@
         const CConsole &console = m_session.GetConsole();
 
-        QString strToolTip = QApplication::translate("VBoxConsoleWnd", "<p style='white-space:pre'><nobr>Indicates the activity of "
+        QString strToolTip = QApplication::translate("UIIndicatorsPool", "<p style='white-space:pre'><nobr>Indicates the activity of "
                                 "the machine's shared folders:</nobr>%1</p>", "Shared folders tooltip");
 
@@ -467,5 +467,5 @@
 
         if (sfs.count() == 0)
-            strFullData = QApplication::translate("VBoxConsoleWnd", "<br><nobr><b>No shared folders</b></nobr>", "Shared folders tooltip");
+            strFullData = QApplication::translate("UIIndicatorsPool", "<br><nobr><b>No shared folders</b></nobr>", "Shared folders tooltip");
 
         setState(!sfs.isEmpty() ? KDeviceActivity_Idle : KDeviceActivity_Null);
@@ -510,9 +510,9 @@
             setState(fVRDPEnabled ? KDeviceActivity_Idle : KDeviceActivity_Null);
 
-            QString tip = QApplication::translate("VBoxConsoleWnd", "Indicates whether the Remote Display (VRDP Server) "
+            QString tip = QApplication::translate("UIIndicatorsPool", "Indicates whether the Remote Display (VRDP Server) "
                              "is enabled (<img src=:/vrdp_16px.png/>) or not "
                              "(<img src=:/vrdp_disabled_16px.png/>).");
             if (vrdpsrv.GetEnabled())
-                tip += QApplication::translate("VBoxConsoleWnd", "<hr>The VRDP Server is listening on port %1").arg(vrdpsrv.GetPorts());
+                tip += QApplication::translate("UIIndicatorsPool", "<hr>The VRDP Server is listening on port %1").arg(vrdpsrv.GetPorts());
             setToolTip(tip);
         }
@@ -566,5 +566,5 @@
             VBoxGlobal::tr("Disabled", "nested paging");
 
-        QString tip(QApplication::translate("VBoxConsoleWnd", "Indicates the status of the hardware virtualization "
+        QString tip(QApplication::translate("UIIndicatorsPool", "Indicates the status of the hardware virtualization "
                        "features used by this virtual machine:"
                        "<br><nobr><b>%1:</b>&nbsp;%2</nobr>"
@@ -576,5 +576,5 @@
         int cpuCount = console.GetMachine().GetCPUCount();
         if (cpuCount > 1)
-            tip += QApplication::translate("VBoxConsoleWnd", "<br><nobr><b>%1:</b>&nbsp;%2</nobr>", "Virtualization Stuff LED")
+            tip += QApplication::translate("UIIndicatorsPool", "<br><nobr><b>%1:</b>&nbsp;%2</nobr>", "Virtualization Stuff LED")
                       .arg(VBoxGlobal::tr("Processor(s)", "details report")).arg(cpuCount);
 
@@ -610,5 +610,5 @@
     void retranslateUi()
     {
-        setToolTip(QApplication::translate("VBoxConsoleWnd", "Indicates whether the host mouse pointer is captured by the guest OS:<br>"
+        setToolTip(QApplication::translate("UIIndicatorsPool", "Indicates whether the host mouse pointer is captured by the guest OS:<br>"
                       "<nobr><img src=:/mouse_disabled_16px.png/>&nbsp;&nbsp;pointer is not captured</nobr><br>"
                       "<nobr><img src=:/mouse_16px.png/>&nbsp;&nbsp;pointer is captured</nobr><br>"
@@ -661,5 +661,5 @@
     void retranslateUi()
     {
-        setToolTip(QApplication::translate("VBoxConsoleWnd", "Indicates whether the keyboard is captured by the guest OS "
+        setToolTip(QApplication::translate("UIIndicatorsPool", "Indicates whether the keyboard is captured by the guest OS "
                       "(<img src=:/hostkey_captured_16px.png/>) or not (<img src=:/hostkey_16px.png/>)."));
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 29733)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 29734)
@@ -383,5 +383,5 @@
         {
             QAction *pAction = actions.at(i);
-            pAction->setText(QApplication::translate("VBoxConsoleWnd", "Preview Monitor %1").arg(pAction->data().toInt() + 1));
+            pAction->setText(QApplication::translate("UIMachineLogic", "Preview Monitor %1").arg(pAction->data().toInt() + 1));
         }
     }
@@ -968,5 +968,5 @@
 
     /* Search for the max available filter index. */
-    QString strNameTemplate = QApplication::translate("VBoxConsoleWnd", "Snapshot %1");
+    QString strNameTemplate = QApplication::translate("UIMachineLogic", "Snapshot %1");
     int iMaxSnapshotIndex = searchMaxSnapshotIndex(machine, machine.GetSnapshot(QString()), strNameTemplate);
     dlg.mLeName->setText(strNameTemplate.arg(++ iMaxSnapshotIndex));
@@ -1044,4 +1044,5 @@
 void UIMachineLogic::sltClose()
 {
+    printf("clvse called\n");
     /* Do not process if window(s) missed! */
     if (!isMachineWindowsCreated())
@@ -1195,12 +1196,12 @@
             {
                 case VBoxDefs::MediumType_DVD:
-                    callVMMAction->setText(QApplication::translate("VBoxConsoleWnd", "More CD/DVD Images..."));
-                    unmountMediumAction->setText(QApplication::translate("VBoxConsoleWnd", "Unmount CD/DVD Device"));
+                    callVMMAction->setText(QApplication::translate("UIMachineLogic", "More CD/DVD Images..."));
+                    unmountMediumAction->setText(QApplication::translate("UIMachineLogic", "Unmount CD/DVD Device"));
                     unmountMediumAction->setIcon(VBoxGlobal::iconSet(":/cd_unmount_16px.png",
                                                                      ":/cd_unmount_dis_16px.png"));
                     break;
                 case VBoxDefs::MediumType_Floppy:
-                    callVMMAction->setText(QApplication::translate("VBoxConsoleWnd", "More Floppy Images..."));
-                    unmountMediumAction->setText(QApplication::translate("VBoxConsoleWnd", "Unmount Floppy Device"));
+                    callVMMAction->setText(QApplication::translate("UIMachineLogic", "More Floppy Images..."));
+                    unmountMediumAction->setText(QApplication::translate("UIMachineLogic", "Unmount Floppy Device"));
                     unmountMediumAction->setIcon(VBoxGlobal::iconSet(":/fd_unmount_16px.png",
                                                                      ":/fd_unmount_dis_16px.png"));
@@ -1221,10 +1222,10 @@
         {
             case VBoxDefs::MediumType_DVD:
-                pEmptyMenuAction->setText(QApplication::translate("VBoxConsoleWnd", "No CD/DVD Devices Attached"));
-                pEmptyMenuAction->setToolTip(QApplication::translate("VBoxConsoleWnd", "No CD/DVD devices attached to that VM"));
+                pEmptyMenuAction->setText(QApplication::translate("UIMachineLogic", "No CD/DVD Devices Attached"));
+                pEmptyMenuAction->setToolTip(QApplication::translate("UIMachineLogic", "No CD/DVD devices attached to that VM"));
                 break;
             case VBoxDefs::MediumType_Floppy:
-                pEmptyMenuAction->setText(QApplication::translate("VBoxConsoleWnd", "No Floppy Devices Attached"));
-                pEmptyMenuAction->setToolTip(QApplication::translate("VBoxConsoleWnd", "No floppy devices attached to that VM"));
+                pEmptyMenuAction->setText(QApplication::translate("UIMachineLogic", "No Floppy Devices Attached"));
+                pEmptyMenuAction->setToolTip(QApplication::translate("UIMachineLogic", "No floppy devices attached to that VM"));
                 break;
             default:
@@ -1332,7 +1333,7 @@
         QAction *pEmptyMenuAction = new QAction(pMenu);
         pEmptyMenuAction->setEnabled(false);
-        pEmptyMenuAction->setText(QApplication::translate("VBoxConsoleWnd", "No USB Devices Connected"));
+        pEmptyMenuAction->setText(QApplication::translate("UIMachineLogic", "No USB Devices Connected"));
         pEmptyMenuAction->setIcon(VBoxGlobal::iconSet(":/delete_16px.png", ":/delete_dis_16px.png"));
-        pEmptyMenuAction->setToolTip(QApplication::translate("VBoxConsoleWnd", "No supported devices connected to the host PC"));
+        pEmptyMenuAction->setToolTip(QApplication::translate("UIMachineLogic", "No supported devices connected to the host PC"));
     }
     else
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 29733)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 29734)
@@ -251,5 +251,5 @@
 
     m_pNameHostkey->setToolTip(
-        QApplication::translate("VBoxConsoleWnd", "Shows the currently assigned Host key.<br>"
+        QApplication::translate("UIMachineWindowNormal", "Shows the currently assigned Host key.<br>"
            "This key, when pressed alone, toggles the keyboard and mouse "
            "capture state. It can also be used in combination with other keys "